# PeriodicTorsionForce Class Reference

This class implements an interaction between groups of four particles that varies periodically with the torsion angle between them. More...

`#include <PeriodicTorsionForce.h>`

Inheritance diagram for PeriodicTorsionForce:

List of all members.

## Classes
class | PeriodicTorsionInfo
| This is an internal class used to record information about a torsion.
## Public Member Functions
| PeriodicTorsionForce ()
| Create a PeriodicTorsionForce.
int | getNumTorsions () const
| Get the number of periodic torsion terms in the potential function.
int | addTorsion (int particle1, int particle2, int particle3, int particle4, int periodicity, double phase, double k)
| Add a periodic torsion term to the force field.
void | getTorsionParameters (int index, int &particle1, int &particle2, int &particle3, int &particle4, int &periodicity, double &phase, double &k) const
| Get the force field parameters for a periodic torsion term.
void | setTorsionParameters (int index, int particle1, int particle2, int particle3, int particle4, int periodicity, double phase, double k)
| Set the force field parameters for a periodic torsion term.
void | updateParametersInContext (Context &context)
| Update the per-torsion parameters in a Context to match those stored in this Force object.
## Protected Member Functions
ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System.

## Detailed Description

This class implements an interaction between groups of four particles that varies periodically with the torsion angle between them.

To use it, create a PeriodicTorsionForce object then call addTorsion() once for each torsion. After a torsion has been added, you can modify its force field parameters by calling setTorsionParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

## Constructor & Destructor Documentation

PeriodicTorsionForce | ( |  | ) |

Create a PeriodicTorsionForce.

## Member Function Documentation

int addTorsion | ( | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | int | particle4,
|  | int | periodicity,
|  | double | phase,
|  | double | k |
| ) |  |  |

Add a periodic torsion term to the force field.

Parameters:

  | particle1 | the index of the first particle forming the torsion
  | particle2 | the index of the second particle forming the torsion
  | particle3 | the index of the third particle forming the torsion
  | particle4 | the index of the fourth particle forming the torsion
  | periodicity | the periodicity of the torsion
  | phase | the phase offset of the torsion, measured in radians
  | k | the force constant for the torsion

Returns:
  the index of the torsion that was added

ForceImpl* createImpl | ( |  | ) | const`[protected, virtual]`

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

int getNumTorsions | ( |  | ) | const`[inline]`

Get the number of periodic torsion terms in the potential function.

void getTorsionParameters | ( | int | index,
|  | int & | particle1,
|  | int & | particle2,
|  | int & | particle3,
|  | int & | particle4,
|  | int & | periodicity,
|  | double & | phase,
|  | double & | k |
| ) |  |  | const

Get the force field parameters for a periodic torsion term.

Parameters:

  | index | the index of the torsion for which to get parameters
  | particle1 | the index of the first particle forming the torsion
  | particle2 | the index of the second particle forming the torsion
  | particle3 | the index of the third particle forming the torsion
  | particle4 | the index of the fourth particle forming the torsion
  | periodicity | the periodicity of the torsion
  | phase | the phase offset of the torsion, measured in radians
  | k | the force constant for the torsion

void setTorsionParameters | ( | int | index,
|  | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | int | particle4,
|  | int | periodicity,
|  | double | phase,
|  | double | k |
| ) |  |  |

Set the force field parameters for a periodic torsion term.

Parameters:

  | index | the index of the torsion for which to set parameters
  | particle1 | the index of the first particle forming the torsion
  | particle2 | the index of the second particle forming the torsion
  | particle3 | the index of the third particle forming the torsion
  | particle4 | the index of the fourth particle forming the torsion
  | periodicity | the periodicity of the torsion
  | phase | the phase offset of the torsion, measured in radians
  | k | the force constant for the torsion

void updateParametersInContext | ( | Context & | context | ) |

Update the per-torsion parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setTorsionParameters() to modify this object's parameters, then call updateParametersInState() to copy them over to the Context.

The only information this method updates is the values of per-torsion parameters. The set of particles involved in a torsion cannot be changed, nor can new torsions be added.

The documentation for this class was generated from the following file:

- PeriodicTorsionForce.h